
# Generate devel rpm
%global with_devel 0
# Build with debug info rpm
%global with_debug 0

%if 0%{?with_debug}
%global _dwz_low_mem_die_limit 0
%else
%global debug_package   %{nil}
%endif

# https://github.com/istio/proxy
%global provider        github
%global provider_tld    com
%global project         istio
%global repo            proxy
%global provider_prefix %{provider}.%{provider_tld}/%{project}/%{repo}
%global envoy_libdir /var/lib/istio/envoy

Name:           istio-proxy
Version:        1.7.3
Release:        1.0.0%{?dist}
Summary:        The Istio Proxy is a microservice proxy that can be used on the client and server side, and forms a microservice mesh. The Proxy supports a large number of features.
License:        ASL 2.0
Vendor:         Oracle America
URL:            https://%{provider_prefix}
ExclusiveArch:  x86_64
Source0:        %{name}-%{version}.tar.bz2
Patch0:         Makefile.core.mk.patch
Patch1:         bazelrc.patch
Patch2:         BUILD.patch

BuildRequires:  lld = 9.0.1
BuildRequires:  automake
BuildRequires:  autoconf
BuildRequires:  autogen
BuildRequires:  libtool
BuildRequires:  libatomic-static
BuildRequires:  libstdc++-static
BuildRequires:  gcc-c++
BuildRequires:  llvm-toolset = 9.0.1
BuildRequires:  clang = 9.0.1
BuildRequires:  perl
BuildRequires:  cmake3
BuildRequires:  python2
BuildRequires:  python3
BuildRequires:  git
BuildRequires:  java-11-openjdk-devel
BuildRequires:  bazel
BuildRequires:  ninja-build
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  golang >= 1.13.5
BuildRequires:  wget

%description
The Istio Proxy is a microservice proxy that can be used on the client and server side, and forms a microservice mesh. The Proxy supports a large number of features.

########### istio-proxy ###############
%package proxy
Summary:  The istio envoy proxy

%description proxy
The Istio Proxy is a microservice proxy that can be used on the client and server side, and forms a microservice mesh. The Proxy supports a large number of features.

This package contains the envoy program.

proxy is the proxy required by the Istio Pilot Agent that talks to Istio pilot

%prep
%setup -q -n %{name}-%{version}

# process the patches
%patch0
%patch1
%patch2

%build
alternatives --set python /usr/bin/python2
export JAVA_HOME=/usr/lib/jvm/java-11-openjdk
export GOROOT=/usr/bin/go

mkdir -p /tmp/envoy-src
envoy_src_rpm_version=$(repoquery --show-duplicates  istio-envoy-1.7.*  -q --qf "%{VERSION}" | tail -1)
envoy_src_rpm="istio-envoy-${envoy_src_rpm_version}"
pushd /tmp/envoy-src
yumdownloader --source istio-envoy-%{VERSION}-%{RELEASE}
rpm2cpio ${envoy_src_rpm}*.rpm|cpio -iv --to-stdout ${envoy_src_rpm}.tar.bz2 > ${envoy_src_rpm}.tar.bz2
tar -xjvf ${envoy_src_rpm}.tar.bz2
popd

export LOCAL_ENVOY_PROJECT=/tmp/envoy-src/${envoy_src_rpm}
chmod +x build_istio_proxy.sh
./build_istio_proxy.sh

%install
rm -rf ${RPM_BUILD_ROOT}
install -d -m755 ${RPM_BUILD_ROOT}/usr/local/bin
install -d -m755 $RPM_BUILD_ROOT/%{envoy_libdir}

cp -pav ./bazel-bin/src/envoy/envoy ${RPM_BUILD_ROOT}/usr/local/bin
install -m644 ./tools/deb/sidecar.env $RPM_BUILD_ROOT%{envoy_libdir}/sidecar.env

%files
/usr/local/bin/envoy
%{envoy_libdir}/sidecar.env
%license LICENSE THIRD_PARTY_LICENSES.txt

%changelog
* Fri Oct 09 2020 Olcne-Builder Jenkins <olcne-builder_us@oracle.com> - 1.7.3-1.0.0
- Added Oracle Specific Build Files for istio/proxy
